
    var IAP = {
        //list: [ 'com.airpersons.airpersonsmobilepsychologist.cashrecharge7', 'com.airpersons.airpersonsmobilepsychologist.cashrecharge_21', 'com.airpersons.airpersonsmobilepsychologist.cashrecharge35' ],
    	list: [],
        products: {},
        loaded: false,
        sandbox: false
    };
    var localStorage = window.localStorage || {};

    IAP.initialize = function () {
        // Check availability of the storekit plugin
        if (!window.storekit) {
        	//navigator.notification.alert(window.storekit);
            console.log('In-App Purchases not available');
            return;
        }
        
        
        if (THE_MAIN_CAT == '437')
        	IAP.list = [ 'com.airpersons.airpersonsmobilepsychologist.cashrecharge7', 'com.airpersons.airpersonsmobilepsychologist.cashrecharge_21', 'com.airpersons.airpersonsmobilepsychologist.cashrecharge35' ];
        else if (THE_MAIN_CAT == '548')
        	IAP.list = [ 'com.airpersons.airpersonsmobilelawyer.cashrecharge7', 'com.airpersons.airpersonsmobilelawyer.cashrecharge21', 'com.airpersons.airpersonsmobilelawyer.cashrecharge35' ];
        else if (THE_MAIN_CAT == '397')
        	IAP.list = [ 'com.airpersons.airpersonsmobilehealth.cashrecharge7', 'com.airpersons.airpersonsmobilehealth.cashrecharge21', 'com.airpersons.airpersonsmobilehealth.cashrecharge35' ];
        else if (THE_MAIN_CAT == '111')
        	IAP.list = [ 'com.airpersons.airpersonsmobileenglish.cashrecharge7', 'com.airpersons.airpersonsmobileenglish.cashrecharge21', 'com.airpersons.airpersonsmobileenglish.cashrecharge35' ];
        else
        	IAP.list = [ 'com.airpersons.airpersonsmobile.cashrecharge7', 'com.airpersons.airpersonsmobile.cashrecharge21', 'com.airpersons.airpersonsmobile.cashrecharge35' ];
        
        

        // Initialize
        storekit.init({
        	debug:    true, // Enable IAP messages on the console
        	noAutoFinish: true,
            ready:    IAP.onReady,
            purchase: IAP.onPurchase,
            finish:   IAP.onFinish,
            restore:  IAP.onRestore,
            error:    IAP.onError,
            restoreCompleted: IAP.onRestoreCompleted
        });
    };

    IAP.onReady = function () {
    	// Once setup is done, load all product data.
        storekit.load(IAP.list, function (products, invalidIds) {
        	console.log("--------------Load product data----------------");
        	IAP.products = products;
        	IAP.loaded = true;
        	for (var j = 0; j < products.length; ++j) {
        		var p = products[j];
        		console.log('Loaded IAP(' + j + ') with id: ' + p.id + '.' + 
        				  ' title:' + p.title +
                          ' description:' + p.description +
                          ' price_iso:' + p.price_iso +
                          ' price_number:' + p.price_number +
                          ' price_symbol:' + p.price_symbol +
                          ' price_country:' + p.price_country);
        		IAP.products[p.id] = p;
        	}
        	IAP.loaded = true;
        	for (var i = 0; i < invalidIds.length; ++i) {
        		console.log("Error: could not load " + invalidIds[i]);
        	}
        	console.log("--------------End load product data----------------");
        	loadPurchasesList();
        });
    };

//////* BUY FUNCTIONS *//
    IAP.onPurchase = function (transactionId, productId, receipt) {
        if ( productId === 'com.airpersons.airpersonsmobilepsychologist.cashrecharge7' || 
        		productId === 'com.airpersons.airpersonsmobilepsychologist.cashrecharge_21' ||
        		productId === 'com.airpersons.airpersonsmobilepsychologist.cashrecharge35' ||
        		productId === 'com.airpersons.airpersonsmobilelawyer.cashrecharge7' ||
        		productId === 'com.airpersons.airpersonsmobilelawyer.cashrecharge21' ||
        		productId === 'com.airpersons.airpersonsmobilelawyer.cashrecharge35' ||
        		productId === 'com.airpersons.airpersonsmobilehealth.cashrecharge7' ||
        		productId === 'com.airpersons.airpersonsmobilehealth.cashrecharge21' ||
        		productId === 'com.airpersons.airpersonsmobilehealth.cashrecharge35' ||
        		productId === 'com.airpersons.airpersonsmobileenglish.cashrecharge7' ||
        		productId === 'com.airpersons.airpersonsmobileenglish.cashrecharge21' ||
        		productId === 'com.airpersons.airpersonsmobileenglish.cashrecharge35' ||
        		productId === 'com.airpersons.airpersonsmobile.cashrecharge7' ||
        		productId === 'com.airpersons.airpersonsmobile.cashrecharge21' ||
        		productId === 'com.airpersons.airpersonsmobile.cashrecharge35' ){
        	
        	/*
        	var n = (localStorage['storekit.' + productId]|0) + 1;
            localStorage['storekit.' + productId] = n;
            if (IAP.purchaseCallback) {
                IAP.purchaseCallback(productId);
                delete IAP.purchaseCallback;
            }
            */
        	
        	storekit.finish(transactionId);
        	
        	storekit.loadReceipts(function (receipts) {
        		receipt = receipts.forProduct(productId);
        		
                //console.log('Receipt for appStore = ' + receipts.appStoreReceipt);
                console.log('Receipt for ' + productId + ' = ' + receipts.forProduct(productId));
                
                IAP.validateReceipt(receipt, IAP.products[productId].price_number, IAP.products[productId].price_iso, IAP.sandbox);
            });
        	
        }
    };

    IAP.buy = function (productId) {
    //IAP.buy = function (productId, callback) {
    //    IAP.purchaseCallback = callback;
        storekit.purchase(productId);
    };
//////* END BUY FUNCTIONS*//
    
    IAP.onFinish = function (transactionId, productId) {
        console.log('Finished transaction for ' + productId + ' : ' + transactionId);
    };
    
    IAP.onError = function (errorCode, errorMessage) {
    	navigator.notification.alert('Error: ' + errorMessage);
    };
    
    IAP.onRestore = function (transactionId, productId) {
        console.log("Restored: " + productId);
        var n = (localStorage['storekit.' + productId]|0) + 1;
        localStorage['storekit.' + productId] = n;
    };

    IAP.restore = function () {
        storekit.restore();
    };
    
    IAP.onRestoreCompleted = function () {
        console.log("Restore Completed");
    };

    IAP.fullVersion = function () {
        return localStorage['storekit.cashrecharge7', 'storekit.cashrecharge_21', 'storekit.cashrecharge35'];
    };

/*    
    IAP.renderIAPs = function (el) {
    	if (IAP.loaded) {
    	    var cash7  = IAP.products["storekit.cashrecharge7"];
    	    var cash21 = IAP.products["storekit.cashrecharge_21"];
    	    var cash35 = IAP.products["storekit.cashrecharge35"];
    	    console.log("----- Listado de productos -----");
    	    for (var id in IAP.products) {
    	    	var prod = IAP.products[id];
    	    	console.log("Producto ID: "+prod.id);
    	    	console.log("Producto Título: "+prod.title);
    	    	console.log("Producto Descripción: "+prod.description);

    	    }
    	    console.log("----- Fin listado de productos -----");
    	}
    	else {
    	    console.log(">>>>>>>>>>>>In-App Purchases not available.");
    	}
    };
*/    
    
    IAP.validateReceipt = function (receipt, value, code, sandbox) {
    	console.log("--- Receipt validation ---");
    	//price = encodeURIComponent(price);
    	$.ajax ({
			type: "POST",
			url: "http://www.airpersons.com/api/user/inapppurchase/",
			dataType: "json",
			data: ( { receipt: receipt, value: value, currencyCode: code, sandbox:sandbox } ),
			headers: {"Accept": "application/json", "Content-Type": "text/html; charset=utf-8"},
			beforeSend : function(req) {
				$("body").append(thisIsLoadScreen);
				req.setRequestHeader("Authorization", "token "+localStorage.getItem("AP_TOKEN"));
            },
            complete: function() { 
            	$(".thisIsLoadScreen").remove();
            },
            success: function( response ) {
            	//navigator.notification.alert("PAGAO");
            	//navigator.notification.alert(JSON.stringify(response));
            	if ( typeof(response.error !== "undefined") )
            	{
            		if (response.error == '0')
        			{	// all OK
            			navigator.notification.alert("Successful cash update.");
        			}else if (response.error == '-1000') {
        				navigator.notification.alert("(-1000) Duplicate payment. This payment is currently done.");
        			}else if (response.error == '-1001') {
        				navigator.notification.alert("(-1001) Update payment conflict. Please, report this inconvenence.");
        			}else if (response.error == '-1002') {
        				navigator.notification.alert("(-1002) Update payment conflict. Please, report this inconvenence");
        			}
            	}
                //window.location = "user-home.html";
            },
            error: function(jqXHR, textStatus, errorThrown) {
                // take action if failed
                if (jqXHR.status == '404')
                	navigator.notification.alert("Not a valid payment.");
                else if (jqXHR.status == '406')
                	navigator.notification.alert("Bad request, ¿payment ok?.");
                else if (jqXHR.status == '409')
                	navigator.notification.alert("recurring payment.");
            }
		});		
	
    };

	
//document.addEventListener('deviceready',IAP.initialize, false);
