
var IAP = {};

IAP.loaded = false;

IAP.initializeStore = function () {

	if (!window.store) {
        alert('Store not available');
        return;
    }
	
    // Let's set a pretty high verbosity level, so that we see a lot of stuff
    // in the console (reassuring us that something is happening).
    store.verbosity = store.INFO;

    // We register a dummy product. It's ok, it shouldn't
    // prevent the store "ready" event from firing.
    store.register({
        id:    "aprecharge1",
        alias: "7 GBP",
        type:  store.CONSUMABLE
    });
    store.register({
        id:    "aprecharge2",
        alias: "14 GBP",
        type:  store.CONSUMABLE
    });
    store.register({
        id:    "aprecharge3",
        alias: "33 GBP",
        type:  store.CONSUMABLE
    });
    
    
    //store.validator = "http://www.airpersons.com/handlers/payments/VerifyInappAndroid.php";
	store.validator = THE_HOST+"v2/inapp/android/check/"+window.localStorage.getItem("AP_ID")+"/"+THE_APP_NAME;
	
    
    
    store.when("product").approved(function(product) {
		console.log("Validate purchase");
		$("#aaabbbccc_IA").text("Validating purchase...");
		product.verify();
	});

	store.when("product").verified(function(product) {
		console.log("You got an EXTRA LIFE!");
		$("#aaabbbccc_IA").text("You got new Credits! ");
	    product.finish();
	});

	store.when("product").owned(function(product) {
	    notify("Product is now owned");
	    //$("#aaabbbccc_IA").append("Product is now owned. ");
	});

	store.when("product").cancelled(function(p) {
	    notify("Transaction CANCELLED");
	    //$("#aaabbbccc_IA").append("Transaction CANCELLED. ");
	});
	
	
	
	store.when("product").error(function(product) {
		console.log("ERROR");
		
	});
    
    
    // When any product gets updated, refresh the HTML.
    store.when("product").updated(function (p) {
    	IAP.renderIAPs(p);
    });
    
    
    // ERROR LOGS
    store.error(function(error) {
        console.log('ERROR ' + error.code + ': ' + error.message);
    });
    
    
    
    	
	
    

    
    

    // When every goes as expected, it's time to celebrate!
    // The "ready" event should be welcomed with music and fireworks,
    // go ask your boss about it! (just in case)
    store.ready(function() {
        console.log("\\o/ STORE READY \\o/");
        IAP.loaded = true;
    });

 
    
    
    // Refresh the store.
    //
    // After we've done our setup, we tell the store to do
    // it's first refresh. Nothing will happen if we do not call store.refresh()
    //
    // This will contact the server to check all registered products
    // validity and ownership status.
    //
    // It's fine to do this only at application startup, as it could be
    // pretty expensive.
    store.refresh();
    
};








IAP.renderIAPs = function (p) {
	
	/*
	p.id
	p.alias
	p.title
	p.description
	p.price
	*/
	
	var elId = p.id;
	var el = $("#"+elId+"-purchase");
    if (!el) return;
    
    el.addClass("ui-disabled");
    if (!p.loaded) {
    	el.text('...');
    }
    else if (!p.valid) {
    	el.text(p.alias + ' Invalid');
    }
    else if (p.valid) 
    {
    	el.text(p.price);
    	el.attr("productId", p.id);
    	
    	if (p.canPurchase) {
        	//console.log ("SE PUEDE COMPRAR");
        	el.removeClass("ui-disabled");
        }
    }

    
};



IAP.showAll = function (){
	
	store.refresh();
	
	var product = store.get("aprecharge1");
	IAP.renderIAPs(product);
	product = store.get("aprecharge2");
	IAP.renderIAPs(product);
	product = store.get("aprecharge3");
	IAP.renderIAPs(product);
	
}



//We must wait for the "deviceready" event to fire
//before we can use the store object.
//document.addEventListener('deviceready', IAP.initializeStore, false);