








//////////////////TAKE PICTURE //////////////////////
function takePicture(gallery, callbackOK, callbackFail)
{
	var camOptions = {
		quality				: 90,
		//destinationType	: Camera.DestinationType.DATA_URL,
		destinationType		: Camera.DestinationType.FILE_URI,
		sourceType			: Camera.PictureSourceType.CAMERA,
		allowEdit 			: false,
		targetWidth			: 640, 
        targetHeight		: 640, 
		saveToPhotoAlbum	: false,
		cameraDirection		: Camera.Direction.FRONT,
		correctOrientation	: true
	};
	
	if (gallery)
		camOptions['sourceType'] = Camera.PictureSourceType.PHOTOLIBRARY;
		
	navigator.camera.getPicture(callbackOK, callbackFail, camOptions);
}



/* Checks that selected input has the max length indicated */
function checkMaxLength(input, max)
{
    if (input.val().length > max) {
        input.val(input.val().substr(0, max));
    }
}



// Function that receive specified service data.
function hasUserImage(callback)
{
	$.ajax ({
		type: "GET",
		url: THE_HOST+"user/image",
		dataType: "json",
		headers: {"Accept": "application/json"},
		beforeSend : function(req) {
        	req.setRequestHeader("Authorization", "token "+localStorage.getItem("AP_TOKEN"));                             
        },
        success: function( response ) 
        {         
        	//console.log(JSON.stringify(response));
        	if (response) {
        		if (response.src) {
        			callback(true);
        			return;
        		}
        	}
        	callback(false);
        	return;
        	
        },
        error: function(jqXHR, textStatus, errorThrown) {
        	
        }
	});
}




/* Obtain user spoken languages and user main language */
function getSpokenLanguages(callbackSuccess, callbackError)
{
	makeDefaultAjaxCall("user/spoken", callbackSuccess, callbackError);
}

/* Obtain user availables languages to create profile */
function getAvailableProfileLanguages(callbackSuccess, callbackError)
{
	makeDefaultAjaxCall("user/availablelanguages", callbackSuccess, callbackError);
}

/* Obtain all user availables languages */
function getAvailableLanguages(callbackSuccess, callbackError)
{
	makeDefaultAjaxCall("v2/user/languages/nospoken", callbackSuccess, callbackError);
}

/* Obtain all countries list */
function getCountries(callbackSuccess, callbackError)
{
	makeDefaultAjaxCall("environment/all/countries", callbackSuccess, callbackError);
}

/* Obtain all countries list */
function getTimezones(callbackSuccess, callbackError)
{
	makeDefaultAjaxCall("environment/all/timezones", callbackSuccess, callbackError);
}

/* Make default ajax launch */
function makeDefaultAjaxCall(url, callbackSuccess, callbackError)
{
	$.ajax({
		url:THE_HOST+url,
		type:"GET",
		headers: {"Accept": "application/json"},
		beforeSend : function(req) {
			$.mobile.loading('show');
        	req.setRequestHeader("Authorization", "token "+localStorage.getItem("AP_TOKEN"));                          
        },
        complete: function() { },
        success: function( response ) 
        {
        	$.mobile.loading('hide');
        	// Obtains all languages list
        	if (response)
        		callbackSuccess(response);
        	else
        		callbackError(null, null);
        },
        error: function(jqXHR, textStatus, errorThrown) {
        	$.mobile.loading('hide');
        	callbackError(jqXHR.status, jqXHR.responseText);
        }
	});
}




/* obtains subcategories tree from selected category */
function getSubcategoriesTree(cat, sub, callback)
{
	$.ajax({
		url:THE_HOST+"environment/categories/"+cat+"?language="+window.localStorage.getItem('AP_LANGUAGE'),
		type:"GET",
		headers: {"Accept": "application/json"},
		beforeSend : function(req) {
			$("#pSubcats_"+sub).empty();
			$('#category_'+sub).attr("disabled", "disabled");
			$("#pSubcats_"+sub).html('<div id="load_"'+sub+' style="text-align: center"> \
										<img src="img/ico/ajax-loader-blue.gif" alt="Loading..." /> \
									</div>');
        	req.setRequestHeader("Authorization", "token "+localStorage.getItem("AP_TOKEN"));                             
        },
        complete: function() {
        	$("#load_"+sub).remove();
        	$('#category_'+sub).attr("disabled", false);
        	//$('#category_'+sub).selectmenu('refresh');
        },
        success: function( response ) 
        {
        	if (response != null)
        	{
            	//console.log(JSON.stringify(response));
            	$("#pSubcats_"+sub).html(populateSubcategoriesList(response, cat, "", sub));
            	if (callback && typeof(callback) === "function")
            		callback(true);
            	return;
        	}
        	if (callback && typeof(callback) === "function")
        		callback(false);
        },
        error: function(jqXHR, textStatus, errorThrown) {
        	if (callback && typeof(callback) === "function")
        		callback(false);
        }
	});
}

function populateSubcategoriesList(elements, parent, grandpas, sub)
{
	var ty = "sv";
	if (sub == "CO")
		ty = "o";
	else if (sub == 'CJ')
		ty = "j";
	
	var list = '<ul data-role="none" class="service-subcats">';
	$.each(elements, function(k,element){
		
		if (element != null)
		{
			if (element.id != null)
				list = list+'<li data-role="none"><input type="checkbox" data-role="none" name="categories_'+ty+'[]" id="categories_'+ty+'-'+element.id+'" class=" subcatsCheck_'+sub+' '+grandpas+' '+parent+'" value="'+element.id+'" /><label for="categories_'+ty+'-'+element.id+'" class="lvl1-subcat-label">&nbsp;'+element.name+'</label><br/></li>';

			if (element.childs != null)
				if (element.childs != null)
					list = list+populateSubcategoriesList(element.childs, parent, grandpas+" "+element.id, sub);
		}
		
	});
	list = list+'</ul>';
	return list;
}



function getMaxPriceOffer(catID, callbackOK, callbackKO)
{
	$.ajax ({
		type: "GET",
		url: THE_HOST+"v2/offers/average/"+catID+"?currency="+window.localStorage.getItem('AP_CURRENCY'),
		dataType: "json",
		headers: {"Accept": "application/json"},
		beforeSend : function(req) {
			$.mobile.loading( "show");
			req.setRequestHeader("Authorization", "token "+localStorage.getItem("AP_TOKEN"));                             
		},
		complete: function() {
			$.mobile.loading('hide');
        },
		success: function( response ) 
		{         
			//console.log(JSON.stringify(response));
			if (response) {
				callbackOK(response);
				return;
			}
			callbackKO(null, null);
			return;
		
		},
		error: function(jqXHR, textStatus, errorThrown) {
			callbackKO(jqXHR.status, jqXHR.responseText);
		}
	});
}




function getProfileList(apID, callbackOK, callbackKO)
{
	$.ajax ({
		type: "GET",
		url: THE_HOST+"v2/profile/"+apID+"/list",
		dataType: "json",
		headers: {"Accept": "application/json"},
		beforeSend : function(req) {
				$.mobile.loading( "show", {
					  text: languageStrings.LOADING,
					  textVisible: true,
					  theme: "b",
					  html: ""
					});
			req.setRequestHeader("Authorization", "token "+localStorage.getItem("AP_TOKEN"));                             
		},
		complete: function() {
			$.mobile.loading('hide');
        },
		success: function( response ) 
		{         
			//console.log(JSON.stringify(response));
			if (response) {
				callbackOK(response);
				return;
			}
			callbackKO(null, null);
			return;
		
		},
		error: function(jqXHR, textStatus, errorThrown) {
			callbackKO(jqXHR.status, jqXHR.responseText);
		}
	});
}



//Function that receive specified service data.
/**
 *  callbackOK returns the server response when its OK
 *  callbackKO returns the server response when any error exists. If response isn't http 2xx,
 *  returns error code and error text. 
 */
function getProfile(apID, lang, callbackOK, callbackKO, options)
{
	if (apID == null || apID == "")
		apID = window.localStorage.getItem("AP_ID");
	
	if (!lang || typeof(lang) === "undefined" || lang == "undefined")
		lang = "";
	
	$.ajax ({
		type: "GET",
		url: THE_HOST+"v2/profile/"+apID+"/"+lang+"?extended=true",
		data:options,
		dataType: "json",
		headers: {"Accept": "application/json"},
		beforeSend : function(req) {
				$.mobile.loading( "show", {
					  text: "...",
					  textVisible: true,
					  theme: "b",
					  html: ""
					});
			req.setRequestHeader("Authorization", "token "+localStorage.getItem("AP_TOKEN"));                             
		},
		complete: function() {
			$.mobile.loading('hide');
        },
		success: function( response ) 
		{         
			//console.log(JSON.stringify(response));
			if (response) {
				callbackOK(response);
				return;
			}
			callbackKO(null, null);
			return;
		
		},
		error: function(jqXHR, textStatus, errorThrown) {
			callbackKO(jqXHR.status, jqXHR.responseText);
		}
	});
}


//Function that receive specified service data.
function deleteSingle(id, type, callbackOK, callbackKO)
{	
	var url = THE_HOST;
	if (type == "service")
		url += "v2/services/"+id+"/delete";
	else if (type == "offer")
		url += "v2/offers/"+id+"/delete";
	else if (type == "job")
		url += "v2/jobs/"+id+"/delete";
	else if (type == "profile")
		url += "v2/profile/"+id+"/delete";
	else
		return false;
	
	
	$.ajax ({
		type: "POST",
		url: url+"?category="+THE_MAIN_CAT,
		dataType: "json",
		headers: {"Accept": "application/json"},
		beforeSend: function(req) {
			$.mobile.loading('show');
			req.setRequestHeader("Authorization", "token "+localStorage.getItem("AP_TOKEN"));
		},
        complete: function() {
        	$.mobile.loading('hide');
        }, 
        success: function( response ) // 200 codes from server 
        {   //console.log(JSON.stringify(response));
			if (response) {
				if ((typeof(response.deleted) !== "undefined") && response.deleted != null){
					if (response.deleted == 1){
						callbackOK(response);
						return;
					}
				}
			}
			callbackKO(null, null);
			return;
        },
        error: function(jqXHR, textStatus, errorThrown) {
        	callbackKO(jqXHR.status, jqXHR.responseText);
        }
	});
}



//Function that enable or disable
function disableSingle(id, type, disable, callbackOK, callbackKO)
{	
	var url = "";
	if (type == "service")
		url = THE_HOST+"v2/services/"+id;
	else if (type == "offer")
		url = THE_HOST+"v2/offers/"+id;
	else if (type == "job")
		url = THE_HOST+"v2/jobs/"+id;
	else if (type == "profile")
		url = THE_HOST+"v2/profile/"+id;
	else
		return false;
	
	if (disable)
		url += "/disable";
	else
		url += "/enable";
	
	
	$.ajax ({
		type: "POST",
		url: url+"?category="+THE_MAIN_CAT,
		dataType: "json",
		headers: {"Accept": "application/json"},
		beforeSend: function(req) {
			$.mobile.loading('show');
			req.setRequestHeader("Authorization", "token "+localStorage.getItem("AP_TOKEN"));
		},
        complete: function() {
        	$.mobile.loading('hide');
        }, 
        success: function( response ) // 200 codes from server 
        {   //console.log(JSON.stringify(response));
			if (response) {
				if ((typeof(response.changed) !== "undefined") && response.changed != null){
					if (response.changed == 1){
						callbackOK(response);
						return;
					}
				}
			}
			callbackKO(null, null);
			return;
        },
        error: function(jqXHR, textStatus, errorThrown) {
        	callbackKO(jqXHR.status, jqXHR.responseText);
        }
	});
}


//Function that receive specified service data.
function getUserMarket(apID, type, callbackOK, callbackKO)
{	
	if (apID == null || apID == "")
		apID = localStorage.getItem("AP_ID");
	
	var url = "";
	if (type == "service")
		url = THE_HOST+"v2/profile/"+apID+"/services?language="+window.localStorage.getItem('AP_LANGUAGE')+"&currency="+window.localStorage.getItem('AP_CURRENCY')+"&extended=true&category="+THE_MAIN_CAT;
	else if (type == "offer")
		url = THE_HOST+"v2/profile/"+apID+"/offers?language="+window.localStorage.getItem('AP_LANGUAGE')+"&currency="+window.localStorage.getItem('AP_CURRENCY')+"&extended=true&category="+THE_MAIN_CAT;
	else if (type == "job")
		url = THE_HOST+"v2/profile/"+apID+"/jobs?language="+window.localStorage.getItem('AP_LANGUAGE')+"&currency="+window.localStorage.getItem('AP_CURRENCY')+"&extended=true&category="+THE_MAIN_CAT;
	else
		return false;
	
		
	$.ajax ({
		type: "GET",
		url: url,
		dataType: "json",
		headers: {"Accept": "application/json"},
		beforeSend: function(req) {
			$.mobile.loading('show');
			req.setRequestHeader("Authorization", "token "+localStorage.getItem("AP_TOKEN"));
		},
        complete: function() {
        	$.mobile.loading('hide');
        }, 
		// 200 codes from server
        success: function( response ) 
        {            		     
        	//alert(JSON.stringify(response));
        	//console.log(JSON.stringify(response));
			if (response) {
				if (type == "service")
					callbackOK(getUserMarketResultService(response, false, "a"));
				else if (type == "job")
					callbackOK(getUserMarketResultJob(response, false));
				else if (type == "offer")
					callbackOK(getUserMarketResultOffer(response, false));
				else
					callbackOK(response);
				return;
			}
			callbackKO(null, null);
			return;
        },
        error: function(jqXHR, textStatus, errorThrown) {
        	//alert(jqXHR.status+" - "+jqXHR.responseText);
        	callbackKO(jqXHR.status, jqXHR.responseText);
        }
	});
}




function getUserMarketResultService(response, checkOnline, model)
{
	var toAppend = "";
	if (response.length > 0)
    {
		var active = "";
		var ava = "";
		var leConnect = "";
		var modeElement = '';
		var inactive_text = '';
    	$.each(response, function(k,s){
    		
    		active = "";
    		inactive_text = '';
    		
    		if (s.online != '0'){
    			if (checkOnline === true)
    				ava = "online";
				leConnect = "Online";
			}else{
				if (checkOnline === true)
					ava = "offline";
				leConnect = "Offline";
			}
    		
			if (s.state)
				if (s.state == '0'){
					active = "inactive";
					inactive_text = '<div class="job-avatar-inactive">\
        				<p>Inactive</p>\
        			</div>';
				}
			
			if (model == "b"){
				if (checkOnline === true && s.online != '0'){
					modeElement = '<p class="live-chat icon-mail">'+languageStrings.QUESTION_ASK+'</p>';
					modeElement += '<p class="job-btn-right">'+leConnect+'</p>';
				}else
					modeElement = '<p class="live-chat icon-webcam">'+languageStrings.LIVE_CHAT+'</p>';
			}
			else
				modeElement = '<p>'+s.main_cat.name+' / '+s.subcategory.name+'</p>';
			
			
			toAppend += 
				'<a href="#" data-role="none" onclick="goToService('+s.id+');">\
					<div class="job '+ava+' '+active+' clearfix">\
						<div class="job-avatar">\
							<img class="job-avatar" src="'+s.picture+'" width="75" height="75" alt="Avatar">\
							'+inactive_text+'\
						</div>\
						<div class="job-data">\
							<h2>'+s.title_short.substring(0,40)+'</h2>\
							<strong class="job-price"><span>'+s.price10+'</span> - 10 min</strong>\
							<p>'+s.free+' '+languageStrings.MIN_FREE+'</p> \
							'+modeElement+'\
						</div>\
					</div>\
				</a>';
//<p class="job-btn">'+leConnect+'</p>\
		});
		
    }
	return toAppend;
}



function getUserMarketResultJob(response, checkOnline)
{
	var toAppend = "";
	if (response.length > 0)
    {
		var active = "";
		var ava = "";
		var modeElement = "";
		var leBuy = languageStrings.BUY;
		var inactive_text = '';
    	$.each(response, function(k,j){
        	
    		modeElement = '';
    		active = "";
    		inactive_text = '';
    		
    		// IF exists state, items owner are the asker
			if (j.state){
				if (j.state == '0'){
					active = "inactive";
					inactive_text = '<div class="job-avatar-inactive">\
                        				<p>Inactive</p>\
                        			</div>';
				}
			}else{ 
				modeElement = '<p class="job-btn-right">'+leBuy+'</p>';
				if (checkOnline === true){
					if (j.online != '0'){	
						ava = "online";
					}else{
						ava = "offline";
					}
				}
			}
    		
    		
			days = languageStrings.DONE_IN.replace("[*****]", j.duration);
			
			toAppend += 
				'<a href="#" data-role="none" onclick="goToJob('+j.id+');">\
					<div class="job mini-job '+ava+' '+active+' clearfix">\
						<div class="job-avatar">\
							<img class="job-avatar" src="'+j.picture+'" width="75" height="75" alt="Avatar">\
							<span class="ribete">MINI-JOB</span>\
							'+inactive_text+'\
						</div>\
						<div class="job-data">\
							<h2><img src="img/flags/16/'+j.language.flag+'" alt="'+j.language.name+'"> '+j.title.substring(0,40)+'</h2>\
							<strong class="job-price"><span>'+j.price+'</span> '+days+'</strong>\
							<p>'+j.main_cat.name+' / '+j.subcategory.name+'</p>\
							'+modeElement+'\
						</div>\
					</div>\
				</a>';
//<p class="job-btn">Comprar</p>			
		});
    }
	return toAppend;
}



function getUserMarketResultOffer(response, checkOnline)
{
	var toAppend = "";
	if (response.length > 0)
    {
		var active = "";
		var ava = "";
		var modeElement = "";
		var leBuy = languageStrings.BUY;
		var inactive_text = '';
    	$.each(response, function(k,o){
    		
    		modeElement = '';
    		active = "";
    		inactive_text = '';
    		
			if (o.state){
				if (o.state == '0'){
					active = "inactive";
					inactive_text = '<div class="job-avatar-inactive">\
        				<p>Inactive</p>\
        			</div>';
				}
			}else{
				modeElement = '<p class="job-btn-right">'+leBuy+'</p>';
				if (checkOnline === true){
					if (o.online != '0'){	
						ava = "online";
					}else{
						ava = "offline";
					}
				}
			}
				
			toAppend += 
				'<a href="#" data-role="none" onclick="goToOffer('+o.id+');">\
					<div class="job discount '+ava+' '+active+' clearfix">\
						<div class="job-avatar">\
							<img class="job-avatar" src="'+o.picture+'" width="75" height="75" alt="Avatar">\
							<span class="ribete ribete-red">'+o.discount+'</span>\
							'+inactive_text+'\
						</div>\
						<div class="job-data">\
							<h2><img src="img/flags/16/'+o.language.flag+'" alt="'+o.language.name+'"/> '+o.title.substring(0,40)+'</h2>\
							<strong class="job-price"><span>'+o.price+'</span> - '+o.duration+'min</strong>\
							<p>'+o.main_cat.name+' / '+o.subcategory.name+'</p>\
							'+modeElement+'\
						</div>\
					</div>\
				</a>';
		});
    }
	return toAppend;
}








//Function that receive specified service data.
function getSingleMarket(id, type, callbackOK, callbackKO)
{	
	var url = "";
	if (type == "service")
		url = THE_HOST+"v2/services/"+id;
	else if (type == "offer")
		url = THE_HOST+"v2/offers/"+id;
	else if (type == "job")
		url = THE_HOST+"v2/jobs/"+id;
	else
		return false;
	
	
	$.ajax ({
		type: "GET",
		url: url+"?language="+window.localStorage.getItem('AP_LANGUAGE')+"&currency="+window.localStorage.getItem('AP_CURRENCY')+"&category="+THE_MAIN_CAT,
		dataType: "json",
		headers: {"Accept": "application/json"},
		beforeSend: function(req) {
			$.mobile.loading('show');
			req.setRequestHeader("Authorization", "token "+localStorage.getItem("AP_TOKEN"));
		},
        complete: function() {
        	$.mobile.loading('hide');
        }, 
		// 200 codes from server
        success: function( response ) 
        {            		     
        	//console.log(JSON.stringify(response));
			if (response) {
				callbackOK(response);
				return;
			}
			callbackKO(null, null);
			return;
        },
        error: function(jqXHR, textStatus, errorThrown) {
        	callbackKO(jqXHR.status, jqXHR.responseText);
        }
	});
}


//Function that receive specified service data.
function getSimilar(id, type, callbackOK, callbackKO)
{	
	var elements = 5;
	var url = "";
	if (type == "service")
		url = THE_HOST+"v2/services/"+id+"/similar/";
	else if (type == "offer")
		url = THE_HOST+"v2/offers/"+id+"/similar/";
	else if (type == "job")
		url = THE_HOST+"v2/jobs/"+id+"/similar/";
	else
		return false;
	
	$.ajax ({
		type: "GET",
		url: url+"?language="+window.localStorage.getItem('AP_LANGUAGE')+"&currency="+window.localStorage.getItem('AP_CURRENCY')+"&elements="+elements+"&category="+THE_MAIN_CAT,
		dataType: "json",
		headers: {"Accept": "application/json"},
		beforeSend: function(req) {
			$.mobile.loading('show');
			req.setRequestHeader("Authorization", "token "+localStorage.getItem("AP_TOKEN"));
		},
        complete: function() {
        	$.mobile.loading('hide');
        }, 
		// 200 codes from server
        success: function( response ) 
        {            		     
        	//console.log(JSON.stringify(response));
			if (response) {
				if (type == "job")
					callbackOK(getUserMarketResultJob(response, true));
				else if (type == "offer")
					callbackOK(getUserMarketResultOffer(response, true));
				else
					callbackOK(response);
					//callbackOK(getUserMarketResultService(response, true, "b"));
				return;
			}
			callbackKO(null, null);
			return;
        },
        error: function(jqXHR, textStatus, errorThrown) {
        	callbackKO(jqXHR.status, jqXHR.responseText);
        }
	});
}



//Function that receive specified service data.
function getUserContacts(apID, callbackOK, callbackKO)
{	
	if (apID == null || apID == "")
		apID = localStorage.getItem("AP_ID");
	
	$.ajax ({
		type: "GET",
		url: THE_HOST+"v2/profile/"+apID+"/contacts?extended=true",
		dataType: "json",
		headers: {"Accept": "application/json"},
		beforeSend: function(req) { 
			req.setRequestHeader("Authorization", "token "+localStorage.getItem("AP_TOKEN"));
			$.mobile.loading('show');
		},
		complete: function() { $.mobile.loading('hide'); }, 
		// 200 codes from server
		success: function( response ) 
		{            		     
			//alert(JSON.stringify(response));
        	//console.log(JSON.stringify(response));
			if (response) {
				callbackOK(response);
				return;
			}
			callbackKO(null, null);
			return;
        },
        error: function(jqXHR, textStatus, errorThrown) {
        	callbackKO(jqXHR.status, jqXHR.responseText);
        }
	});
}



// PROFILE FUNCTIONS
function goToProfile(ap_id, iso, back)
{
	localStorage.profile_id = ap_id;
	localStorage.profile_language = iso;	
	if (back)
		$.mobile.changePage("#view-profile", {allowSamePageTransition: true});
	else{		
		$.mobile.changePage("#view-profile", {changeHash: false, allowSamePageTransition: true});
	}
}

// iso "" or null for create.
function goToCreateProfile()
{
	localStorage.removeItem("profile_edit_language");
	$.mobile.changePage("#new-profile");
}

function goToEditProfile(iso)
{
	localStorage.profile_edit_language = iso;
	//$.mobile.changePage("#new-profile");
	$.mobile.changePage("#new-profile", {
    //	reverse: false,
		changeHash: false
	});
}


// SERVICE FUNCTIONS
function goToService(sv_id)
{
	localStorage.sv_id = sv_id;
	$.mobile.changePage("#view-service", {allowSamePageTransition: true});
}

function goToCreateService()
{
	localStorage.removeItem("edit_sv_id");
	$.mobile.changePage("#create-service");
	//$.mobile.changePage( "#create-service", {
    //    reverse: false,
    //    changeHash: false
    //});
}

function goToEditService(sv_id)
{
	localStorage.edit_sv_id = sv_id;
	//$.mobile.changePage("#create-service");
	$.mobile.changePage( "#create-service", {
	//	reverse: false,
		changeHash: false
	});
}

// OFFER FUNCTIONS 
function goToOffer(o_id)
{
	localStorage.offer_id = o_id;
	$.mobile.changePage("#view-offer", {allowSamePageTransition: true});
}

function goToCreateOffer()
{
	localStorage.removeItem("edit_offer_id");
	$.mobile.changePage("#create-offer");
	//$.mobile.changePage( "#create-offer", {
    //    reverse: false,
    //    changeHash: false
    //});
}

function goToEditOffer(o_id)
{
	localStorage.edit_offer_id = o_id;
	//$.mobile.changePage("#create-offer");
	$.mobile.changePage("#create-offer", {
    //	reverse: false,
		changeHash: false
	});
}


// JOB FUNCTIONS
function goToJob(j_id)
{
	localStorage.job_id = j_id;
	$.mobile.changePage("#view-job", {allowSamePageTransition: true});
}

function goToCreateJob()
{
	localStorage.removeItem("edit_job_id");
	$.mobile.changePage("#create-job");
	//$.mobile.changePage("#create-job", {
    //    reverse: false,
    //    changeHash: false
    //});
}

function goToEditJob(j_id)
{
	localStorage.edit_job_id = j_id;
	//$.mobile.changePage("#create-job");
	$.mobile.changePage("#create-job", {
		changeHash: false
	});
}




function goToReviews(id, type)
{
	localStorage.review_type = type;
	localStorage.review_id = id;
	$.mobile.changePage("#view-reviews", {allowSamePageTransition: true});
}

function goToMessage(id, type)
{
	window.localStorage.message_id = id; 
	window.localStorage.message_type = type;
	$.mobile.changePage("#view-message", {allowSamePageTransition: true});
}


function goToAsk(id, type, text, image)
{
	window.localStorage.ask_id = id; 
	window.localStorage.ask_type = type;
	window.localStorage.ask_text = text; 
	window.localStorage.ask_image = image;
	$.mobile.changePage("#ask-question", {allowSamePageTransition: true});
}


function goToReport(id, type, text, image)
{
	window.localStorage.report_id = id; 
	window.localStorage.report_type = type;
	window.localStorage.report_text = text; 
	window.localStorage.report_image = image;
	$.mobile.changePage("#report");
}

function goToFriendRequest(id, text, image)
{
	window.localStorage.friend_id = id; 
	window.localStorage.friend_text = text; 
	window.localStorage.friend_image = image;
	$.mobile.changePage("#friend-request");
}

function goToAppointment(id, type){
	if (type.toLowerCase() == 'service'){
		localStorage.removeItem("appointment_of");
		window.localStorage.appointment_sv = id;
	}else if (type.toLowerCase() == 'offer'){
		localStorage.removeItem("appointment_sv");
		window.localStorage.appointment_of = id;
	}else 
		return;
	$.mobile.changePage("#appointment");
}

function goToRoom(apm){
	window.localStorage.room_id = apm;
	$.mobile.changePage("#room");
}

function goToSummary(id){
	window.localStorage.summary_id = id;
	$.mobile.changePage("#service_summary");
}

function goToJobConversation(conv){
	window.localStorage.conversation_code = conv;
	$.mobile.changePage("#job-conversation", {allowSamePageTransition: true});
}


//
// type must be "SALE", "PURCHASE"
// filter must be "SERVICE", "OFFER", "JOB", "APPOINTMENT"
function goToPurchases(type, filter){
	window.localStorage.purchases_type = type;
	window.localStorage.purchases_filter = filter;
	$.mobile.changePage("#purchases");
}

