// Wait for Cordova to load
//
// Cordova is ready
//
function onDeviceReadyContacts() {
	if (localStorage.getItem("AP_IMPORTED") != '1' && localStorage.getItem("AP_TOKEN") !== null)
	{
        // find all contacts
        var optionsContacts = new ContactFindOptions();
        optionsContacts.filter="";
        optionsContacts.multiple = true;
        var filter = ["displayName", "name", "emails", "phoneNumbers"];
        navigator.contacts.find(filter, onSuccessContacts, onErrorContacts, optionsContacts);
	}
}

// onSuccess: Get a snapshot of the current contacts
//
function onSuccessContacts(contacts) {
    // Create json object
    var jsonContacts = {
        number:contacts.length,
        list:[],
    deviceInfo: {platform:device.platform, version:device.version, model:device.model, name:device.name}
    }; //declare object
    
    //console.log("---------------------------------\n");
    // display the address information for all contacts
    for (var i=0; i<contacts.length; i++) {
       
        // Emails data
        if (contacts[i].emails != null)
        {
            var name = "";
            // If hasn't name, set empty name
            if (contacts[i].name != null)
                name = contacts[i].name.formatted;
            var emailList = [];
            for (var j=0; j<contacts[i].emails.length; j++) {
                emailList.push(contacts[i].emails[j].value);
                //console.log(", Value: "  + contacts[i].emails[j].value);
            }
            // Gets phone numbers os the selected contact
/*            if (contacts[i].phoneNumbers != null)
            {
                var phoneList = [];
                for (var j=0; j<contacts[i].phoneNumbers.length; j++) {
                    var p = contacts[i].phoneNumbers[j].value
                    p = p.replace(/\s/g,"");
                    phoneList.push(p);
                }
            }
*/            jsonContacts.list.push({
                        "name"      : name,
                        "emails"    : emailList /*,
                        "phones"    : phoneList*/
            });
        }
        
    }
    //console.log(JSON.stringify(jsonContacts));
    //console.log("---------------------------------\n");
    sentUserContacts(jsonContacts);
};

// onError: Failed to get the contacts
//
function onErrorContacts(contactError) {
    console.log("No se puede acceder a contactos "+contactError);
    //alert('onError!');
}



// Sent the user contacts to the server
function sentUserContacts(contacts)
{
    if (localStorage.getItem("AP_TOKEN") == null)
        return;
    var hash = $.base64.encode(JSON.stringify(contacts));
    $.ajax ({
        type: "POST",
        url: "http://www.airpersons.com/api/login/mobileContacts",
        dataType: "json",
        data: ( { contacts: hash, category:THE_MAIN_CAT } ),
        headers: {"Accept": "application/json"},
        beforeSend: function(req) {
        req.setRequestHeader("Authorization", "token "+localStorage.getItem("AP_TOKEN"));},
        success: function( response ) {
            // take action if successful
            console.log("Imported contacts. "+JSON.stringify(response));
        },
        error: function(jqXHR, textStatus, errorThrown) {
            console.log("enviar mobileContacts mal");
            // take action if failed
            if (jqXHR.status == '404')
            {}
            else if (jqXHR.status == '406')
            {}
        }
    });
}