var app = {
    // Application Constructor
    initialize: function() {
        this.bindEvents();
    },
    
    // Bind Event Listeners
    //
    // Bind any events that are required on startup. Common events are:
    // 'load', 'deviceready', 'offline', and 'online'.
    bindEvents: function() {
        document.addEventListener('deviceready', this.onDeviceReady, false);
    },
    
    // deviceready Event Handler
    //
    // The scope of 'this' is the event. In order to call the 'receivedEvent'
    // function, we must explicity call 'app.receivedEvent(...);'
    onDeviceReady: function() {
       // if (window.localStorage.getItem("AP_JUST_LOGIN") == "0")
        if (localStorage.getItem("AP_TOKEN"))
        	app.receivedEvent('deviceready');
    },
    
    unRegister : function () {
    	window.plugins.pushNotification.unregister(this.onUnregisterGCM, this.errorHandler );
    },
    
    tokenHandler:function(msg) {
        console.log("Token Handler " + msg);
        window.app.sendRegisterToServer(msg);
    },
    
    errorHandler:function(error) {
        console.log("Error Handler  " + error);
        //alert(error);
    },
    
    // result contains any message sent from the plugin call
    successHandler: function(result) {
        console.log('Success! Result = '+result);
    },
    
    // Update DOM on a Received Event
    receivedEvent: function(id) {
        var pushNotification = window.plugins.pushNotification;
        // TODO: Enter your own GCM Sender ID in the register call for Android
        if (device.platform == 'android' || device.platform == 'Android') {
            pushNotification.register(this.onRegisterGCM, this.errorHandler, {"senderID":THE_PUSH_KEY,"ecb":"app.onNotificationGCM"});
        }
        else if (device.platform == 'ios' || device.platform == 'iOS') {
            pushNotification.register(this.tokenHandler, this.errorHandler, {"badge":"true","sound":"true","alert":"true","ecb":"app.onNotificationAPN"});
        }
		else if(device.platform == "Win32NT") {
			/*
			pushNotification.unregister(
				app.errorHandlerERRCB, app.errorHandlerERRCB,
					{
						"channelName": "airpersonsmobilepsychologist_Channel"
					});
			*/
			pushNotification.register(
				app.channelHandlerUCCB,
				app.errorHandlerERRCB,
				{
					"channelName": THE_APP_NAME,
					"ecb": "app.onNotificationMPNS",
					"uccb": "app.channelHandlerUCCB",
					"errcb": "app.errorHandlerERRCB"
				});
        }
        
        console.log('Received Event: ' + id);
    },
    
    // iOS
    onNotificationAPN: function(event) {
        var pushNotification = window.plugins.pushNotification;
        console.log("Received a notification! " + event.alert);
        console.log("event " + JSON.stringify(event));
        if (event.alert) {
        	//if (event.foreground == '0')
        	if (event.action1 == "IN_CALL")
        	{
        		if (!with_conversation){
        			//with_conversation = true;
        			document.addEventListener('deviceready', this.callingPush(event), false);
        		}
        	}else
        	{
        		document.addEventListener('deviceready', this.notificationPush(event), false);
        	}
        }
        if (event.badge) {
//        	if (event.foreground == '0')
//        	{
	            console.log("Set badge on  " + pushNotification);
	            pushNotification.setApplicationIconBadgeNumber(this.successHandler, this.errorHandler, event.badge);
//        	}
        }
        if (event.sound) {
            var snd = new Media(event.sound);
            snd.play();
        }
    },
    
    // Android
    onNotificationGCM: function(e) {
        switch( e.event )
        {
            case 'registered':
                if ( e.regid.length > 0 )
                {
                    // Your GCM push server needs to know the regID before it can push to this device
                    // here is where you might want to send it the regID for later use.
                    //alert('REGISTERED -> registration id = '+e.regid);
                	console.log('GCM_Success -> We have successfully receive GCM_Event:registered -> REGID has backed from Google');
                	this.sendRegisterToServer(e.regid);
                }
            break;

            case 'message':
            	// this is the actual push notification. its format depends on the data model
            	// of the intermediary push server which must also be reflected in GCMIntentService.java
            	//alert('message = '+e.message+' msgcnt = '+e.msgcnt);
            	//alert(JSON.stringify(e));
            	console.log("<=====MESSAGE====>"+JSON.stringify(e));
				if (e.foreground)
				{
					// if the notification contains a soundname, play it.
					//var my_media = new Media("/android_asset/www/"+e.soundname);
					//my_media.play();
					console.log(">------>Foreground<-----< ");
					if (e.payload.action1 == "IN_CALL")
			    		document.addEventListener('deviceready', this.callingPush(e.payload), false);
			    	else if (e.payload.action1 == "NT"){
			    		if( $.mobile.activePage.is('#notifications') ) {
			    			// if current page is notifications, reload it.
			    			getNotificationsList_NT();
			    		}
			    	//	document.addEventListener('deviceready', this.notificationPush(e.payload), false);
			    	}
				}
				else
				{   // otherwise we were launched because the user touched a notification in the notification tray.   
					if (e.payload.action1 == "IN_CALL")
			    		document.addEventListener('deviceready', this.callingPush(e.payload), false);
			    	//else if (e.payload.action1 == "NT")
					else
			    		document.addEventListener('deviceready', this.notificationPush(e.payload), false);

					if (e.coldstart)
					{//$("#app-status-ul").append('<li>--COLDSTART NOTIFICATION--' + '</li>');
						console.log(">------>Coldstart<-----< ");
						//////////////////////////////////////////////////
						// IF ONLY WANT PUSH FOR COLDSTART, PUT CODE HERE
						//////////////////////////////////////////////////
					}else
					{//$("#app-status-ul").append('<li>--BACKGROUND NOTIFICATION--' + '</li>');
						console.log(">------>Background<-----< ");
					}
					//////////////////////////////////////////////////
					// IF WANT PUSH FOR BACKGROUND/COLDSTART, PUT CODE HERE
					//////////////////////////////////////////////////
				
				}
              	//////////////////////////////////////////////////
				// IF WANT PUSH ALWAYS, PUT CODE HERE
              	
				//////////////////////////////////////////////////
            break;

            case 'error':
              alert('GCM error = '+e.msg);
            break;

            default:
              alert('An unknown GCM event has occurred');
              break;
        }
    },
    
    // WP8
	onNotificationMPNS: function(e) {

		console.log("-----RECEIVE PUSH WP");
		console.log(JSON.stringify(e));

		if (e.type == "toast" && e.jsonContent) {
			
			if (toBackground) {	
				// APP IS CURRENTLY ON BACKGROUND
				
				window.plugins.pushNotification.showToastNotification(
					app.successShowToastWP, 
					app.errorShowToastWP,
					{"Title": e.jsonContent["wp:Text1"], "Subtitle": e.jsonContent["wp:Text2"]}
				);
			}else{
				// APP IS CURRENTLY ON FOREGROUND

				var wpCall = JSON.parse(e.jsonContent["wp:Call"]);
				if (wpCall.action1 == "IN_CALL")
			    	document.addEventListener('deviceready', this.callingPush(wpCall), false);
				//else if (wpCall.action1 == "NT")
				else
			    	document.addEventListener('deviceready', this.notificationPush(wpCall), false);
			}

		}

		if (e.type == "raw" && e.jsonContent) {
			console.log("Currently not used");
			//console.log(e.jsonContent.Body);
		}
	},
	errorHandlerERRCB: function(error) {
		console.log("------- errorHandlerERRCB ------------");

	},
	channelHandlerUCCB: function(event) {
		console.log("------- channelHandlerUCCB ------------");
		var uri = event.uri;
		//console.log("uri: " + uri);
		// If uri exists, send it to create push registry
		if (uri) {
			app.sendRegisterToServer(uri);
		}

	},
	successShowToastWP: function(result) {
		console.log("------- successShowToastWP ------------");

	},
	errorShowToastWP: function(error) {
		console.log("------- errorShowToastWP ------------");

	},
    
	
    
    onRegisterGCM: function(e) {
    	//alert('Unregister! Result = '+result)
    	console.log('GCM_Success -> We have successfully unregistered and called the GCM plugin, waiting for GCM_Event:registered -> REGID back from Google');
    },
    
    onUnregisterGCM: function(e) {
    	//alert('Unregister! Result = '+result)
    	console.log('GCM_Success -> We have successfully unregistered and called the GCM plugin, waiting for GCM_Event:registered -> REGID back from Google');
    },
    
    sendRegisterToServer: function (regid) {
    	// ==============================================================================
    	// ==============================================================================
    	// ==============================================================================
        //
        // This is where you would code to send the REGID to your server for this device
    	var jsonData = {
      		  	deviceToken:regid,
      		  	deviceUuid:window.device.uuid,
      		  	devicePlatform:window.device.platform,
      		  	deviceModel:window.device.model,
      		  	deviceSystemVersion:window.device.version,
      		  	appName:THE_APP_NAME,
      		  	appVersion:THE_APP_VERSION 
      	    }; //declare object
     
    	
    	//console.log(JSON.stringify(jsonData));
        var hash = $.base64.encode(JSON.stringify(jsonData));
        $.ajax ({
                type: "POST",
                url: THE_HOST+"login/deviceInfo",
                dataType: "json",
                data: ( { info: hash } ),
                headers: {"Accept": "application/json"},
                beforeSend: function(req) {
                req.setRequestHeader("Authorization", "token "+window.localStorage.getItem("AP_TOKEN"));},
                success: function( response ) {
                    // take action if successful
                	//console.log(JSON.stringify(response));
                	//window.localStorage.setItem("AP_JUST_LOGIN","1");
                	window.localStorage.setItem("AP_REG_ID",regid);
                },
                error: function(jqXHR, textStatus, errorThrown) {
                    //alert("mal");
                    // take action if failed
                    if (jqXHR.status == '404')
                    {}
                    else if (jqXHR.status == '406')
                    {}
                }
        });
        //
        // ==============================================================================
        // ==============================================================================
        // ==============================================================================
    },
    
    callingPush: function (event) {
    	var d = new Date();
		var s = Math.round(d.getTime() / 1000);
		console.log(":::::::::::::::::timestamps::::::::::::::::::");
		console.log("timestamp generado:"+s+"  timestamp recibido:"+event.timestamp);
		console.log(":::::::::::::::::::::::::::::::::::::::::::::");
		if (parseInt(s) - parseInt(event.timestamp) > 60 ) // more than 60 seconds, missing call
		{
			console.log("<=====LLAMADA PERDIDA====>"+JSON.stringify(event));
			alert("Missing call from "+event.message);
		}else 
		{
			console.log("====>"+event.bodyCall);
			console.log("====>"+event.action1);
			if (event.action1 == "IN_CALL" && !with_conversation)
			{
				console.log("<=====LLAMADA ENTRANTE====>"+JSON.stringify(event));
				with_conversation = true;
				Chat.to = event.usrJID;
                Chat.my_key = event.bodyCall;
                Chat.callID = event.convID;
                Chat.aux_inout = "IN"; 
                setTimeout(function () {
                	$(':mobile-pagecontainer').pagecontainer('change', '#called', {
	                    reverse: false,
	                    changeHash: false
	                });
                }, 1000);
			}
		}
    },
    
    notificationPush: function (event) {
    	console.log("<=====NOTIFICACION ENTRANTE====>"+JSON.stringify(event));
    	
    	// Reserved for ack signal. Check if current device has push enabled.
    	if (event.action1 == 'ACK')
    		return;
    	
    	
    	if (!with_conversation)
    	{
	    	var myRedirect = "";

			if (event.action1 == 'NT' || event.action1 == 'PROMO')
			{	// if users isnt busy, go to notifications panel.
				localStorage.setItem('notification_type', event.action1);
	    		myRedirect = "notifications";
			}else if (event.action1 == 'MSG' || event.action1 == 'QST' || event.action1 == 'ANS')
			{	// if users isnt busy, go to notifications panel.
	    		myRedirect = "user-messages";
			}else if (event.action1 == 'SG_PROFILE'){
				myRedirect = "profiles";
			}else if (event.action1 == 'SG_SERVICE'){
				myRedirect = "services";
			}else if (event.action1 == 'SG_JOB'){
				myRedirect = "jobs";
			}else if (event.action1 == 'SG_OFFER'){
				myRedirect = "offers";
			}else if (event.action1 == 'SG_CONFIG'){
				myRedirect = "config";
			}else if (event.action1 == 'SG_QUESTIONS'){
				localStorage.setItem('messages_type', "questions");
				myRedirect = "user-messages";
			}
				

			if (myRedirect !== ""){
				setTimeout(function () {
	    			//$.mobile.changePage("#"+myRedirect);
					$(':mobile-pagecontainer').pagecontainer('change', '#'+myRedirect, {});
	    		}, 100);
			}
    	}
    }
    
    
};
app.initialize();