/**
 * Cliente para API de VideoService
 * 
 * Ejemplo de uso:
 * 
   $("#test-video").click(function() {
        var key_test = "xA5Ufff8KHVA6XKVQJHY3GZuzNgTjHrv";
        $().videoservice({
            key : key_test,
            callback : function (data)
            {
                var conversation = data.conversation;
                var role = 'called';
                if (conversation.caller_token == key_test) role = 'caller';
                window.videoservice(
                        conversation.session,
                        conversation.caller_token,
                        conversation.called_token,
                        role,
                        function(){});
            }
        });
    });
 * 
 */
(function($) {
	var vcj = null;
    var vcc = null;
    var role = null;
    var userKey = "";
    var retries = 0;
    var retriesAssignChat = 0;
    var action = "start";
    var iAmOnlineRetries = 2;
    var callDisconectedByUser = false;
    var iAmAliveTimeout = 10000;
    var finishCode = false;
    var timerOtherAlive = null;
    var controlAlive = null;
    var alwaysAlive = false;
    
    //var endpoint = "http://pickle.mgabarda.com/video-service";
    //var BOSH_SERVICE = 'http://pickle.mgabarda.com:7070/http-bind/';
    var endpoint = "http://videochat.airpersons.info/video-service";
    var BOSH_SERVICE = 'http://pickle.mgabarda.com/http-bind/';
	
	$.fn.reset_chat_alive = function () {
		vcj = null;
	    vcc = null;
	    role = null;
	    userKey = "";
	    retries = 0;
	    retriesAssignChat = 0;
	    action = "start";
	    iAmOnlineRetries = 2;
	    callDisconectedByUser = false;
	    iAmAliveTimeout = 10000;
	    finishCode = false;
	    if (timerOtherAlive)
    		clearTimeout(timerOtherAlive);
	    timerOtherAlive = null;
	    if (controlAlive)
    		clearTimeout(controlAlive);
	    controlAlive = null
	    alwaysAlive = false;
	};
    
    $.fn.videoservice_chat_jid = function () {return vcj;};
    $.fn.videoservice_chat_connection = function () {return vcc;};
    $.fn.set_role = function (r) {role = r;};
    $.fn.get_role = function () {return role;};
    $.fn.set_disconnect = function (r) {callDisconectedByUser = r;};
    $.fn.set_always_alive = function (r) {alwaysAlive = r;};
    //
    $.fn.finish_chat_alive = function (action) {

    	if (!action)
    		action = "end";

    	if (action == 'wait'){
    		callDisconectedByUser = false;
    		action = 'start';
    	}else {
    		callDisconectedByUser = true;
    		
    		if (controlAlive)
        		clearTimeout(controlAlive);
    		$().iAmOnline(userKey, action);
    		
    		vcj = null;
        	vcc = null;
        	role = null;
        	
        	if (timerOtherAlive)
        		clearTimeout(timerOtherAlive);
    	}
    	
    };
    
    
    
    
    
    
    
    
/*    
    // Pause chat
    $.fn.pause_chat_alive = function () {
    	if (controlAlive)
    		clearTimeout(controlAlive);
    	if (timerOtherAlive)
    		clearTimeout(timerOtherAlive);
    	callDisconectedByUser = true;
    	vcc.disconnect();
    	vcj = null;
    };
    
    $.fn.continue_chat_alive = function () {
    	callDisconectedByUser = false;
    	update_others_jid(userKey, callback);
    	controlAlive = setTimeout(function () { $().iAmOnline(theKey, theAction); }, iAmAliveTimeout);			// TIMEOUT
    };
    
*/    
    
    
    
    
    
    
    
    
    /// Chat callback caller
    $.fn.videoservice_chat_message_receive = function (callback) 
    {
    	if (callback && typeof(callback) === "function") {  
            callback();  
        }
    };
    $.fn.send_message = function (text, callback) {
    	//$().send_message(text, callback);
    	if (vcj != null && vcc != null)
		{
			if (vcc.connected)
			{
				var message = $msg({to: vcj, from: vcc.jid, type: 'chat'}).c('body').t(text);
				vcc.send(message);

				callback();
			} else {
				//alert("connected = false");
				}
		} else {
			//alert("not exists");
			//callIsDead("205");
		}
    };
    // Obtiene el chat interno de la conversación
    $.fn.videoservice_update_chat = function ( options )
    {
        var settings = $.extend( {
            'callback' : function (data) {}
        }, options);

        vcc = null;
        function onConnect(status)
        {
            if (status == Strophe.Status.CONNECTED)
            {
            	retries = 0;
            	//vcj = connection.jid;
            	userKey = options.key;
                assignOtherJid(options.key);

            	vcc.send($pres());
            	
            }
            else if (status == Strophe.Status.CONNFAIL)
            {
                console.log('VIDEO_CHAT_PLUGIN: Videochat strophe fail to connect.');
                // Reconnect
                if (retries < 5)
                {
                	retries = retries + 1;
                	doConnect();
                } else
                	console.log('VIDEO_CHAT_PLUGIN: Strophe failed: TOO MANY RECONNECTIONS.');
            }
            else if (status == Strophe.Status.DISCONNECTED)
            {
                console.console.log('VIDEO_CHAT_PLUGIN: Strophe is disconnected.');
                retries = 0;
                if (!callDisconectedByUser)
                	doConnect();
            }
		}
        
        
        function onPresence (presence) {
        	var from = presence.getAttribute("from");
        	var show = "";
        	var status = "";
        	var ptype = $(presence).attr("type");
        	
        	Strophe.forEachChild(presence, "show", function(elem) {
        		show = elem.textContent;
        	});
        	Strophe.forEachChild(presence, "status", function(elem) {
        		status = elem.textContent;
        	});
        	if (show || status){
        		console.log("[presence] " + from + ":" + status + " " + show);
        	}
        	
        	
        	
    		if (ptype !== "error") {
    			if (ptype === "unavailable") {
    				//alert("unavailable");
    				//var presence = $pres().c('priority').t('1').up().c('status').t('Airpersons mobile');
    				//vcc.send(presence);
    			} else {
    				var show = $(presence).find("show").text();
    				if (show === "" || show === "chat") {
    				
    				} else {
    				
    				}
    			}			
    		}
    		return true;
    	}
        
     // KEEP CONNECTION ALIVE
        function onPingHandler(ping) {
        	var pingId = ping.getAttribute("id");
        	var from = ping.getAttribute("from");
        	var to = ping.getAttribute("to");
        	var pong = $iq({type: "result", "to": from, id: pingId, "from": to});
        	vcc.send(pong);
        	// Indicate that this handler should be called repeatedly
        	return true;
        }
        
        
        function onMessage (message) {
			//alert("viene mensaje: "+message.toString);
        	//console.log(message.toString);
			var body = $(message).find("body");
			var from = $(message).find("from");
			if (body.length !== 0)
				body = body.text();
			else
				body = "";
			
			if (body) {	
				publishOtherChat(body);
				//$("#dChat_T").append('<p><span class="other"><strong>Other</strong>'+body+'</span></p>');
			}
			return true;
        }
        
        function update_others_jid(theKey, callback)
        {
//            if (!vcj)
//            {
                $.ajax({
                    url : endpoint + '/conversations/get_chat/'+theKey,
                    type : 'POST',
                    dataType : 'json'
                }).done(function(data){
                	//console.log(JSON.stringify(data));
                	callback(data);
                }).fail(function() {
                	//console.log("FAILLLLL");
                	timerOtherAlive = setTimeout(function () { update_others_jid(theKey, callback); }, 500);			// TIMEOUT
                });
//            }
        }
        
        // First time update. Start all things.
        function updateOthersA(data)
        {
        	if (data && data.jid)
            {
            	vcj = data.jid;
            	console.log("-----jid: "+vcj);
            	retriesAssignChat = 0;
                //alert("role: "+role+" jid: "+vcj);
            	if (action == "start"){
            		$().iAmOnline(userKey, action);					// <------ start alive handler
            		options.callback();
            		onChats(true, true);
            	}
        		//onChats(true, true);                        
            	
        		timerOtherAlive = setTimeout(function () { update_others_jid(userKey, updateOthersB); }, 10000);			// TIMEOUT
            }else
        	{	// RETRY until it returns other_jid
            	if (retriesAssignChat > 30)
            	{
            		$().reset_chat_alive();
            		callIsDead("202");
            	}else
            	{
            		timerOtherAlive = setTimeout(function () { update_others_jid(userKey, updateOthersA); }, 2000);			// TIMEOUT
            		retriesAssignChat++; 
            	}
        	}
        }
        
        // Timer that check if other user has exit and enter again to the conversation
        function updateOthersB(data)
        {
        	if (data && data.jid)
            {
        		if (vcj != data.jid){
        			vcj = data.jid;
            		console.log("-----jid: "+vcj);
        		}
            }
        	timerOtherAlive = setTimeout(function () { update_others_jid(userKey, updateOthersB); }, 9000);			// TIMEOUT
        }
        
        
        function assignOtherJid(theKey)
        {
        	//console.log(endpoint + '/conversations/update_chat/' + theKey + '?_method=POST&jid='+vcc.jid);
        	//vcj = connection.jid;
            $.ajax({
                url : endpoint + '/conversations/update_chat/' + theKey,
                type : 'POST',
                data : { jid : vcc.jid}, 
                dataType : 'jsonp'
            }).done(function (data) {
                //console.log(JSON.stringify(data));
            	//console.log("updated chat");

            	update_others_jid(theKey, updateOthersA);             
            }).fail(function() {
            	//console.log("FAILLLLL");
            	setTimeout(function () { assignOtherJid(theKey); }, 200);			// TIMEOUT
            });
        }
        
        
        function send_message(text, callback)
        {
        	if (vcj != null && vcc != null)
			{
				if (vcc.connected)
				{
					if( text != null && text != "" && text.length > 0) {
						var message = $msg({to: Chat.to, type:"chat"}).c("body").t(text);
						vcc.send(message);
					}

					callback();
				} else {
					//alert("connected = false");
					}
			} else {
				//alert("not exists");
				//callIsDead("205");
			}
        }
        
       
        function doConnect()
        {
        	vcc = new Strophe.Connection(BOSH_SERVICE);
        	vcc.rawInput = function(data) {
        		//console.log(data);
        	};
        	vcc.rawOutput = function(data) {
        		//console.log(data);
        	};
        	vcc.connect('example.com', null, onConnect);
	        //vcc = thisConnection;
        	
            vcc.addHandler(onMessage, null, 'message', 'chat');
			vcc.addHandler(onPingHandler, "urn:xmpp:ping", "iq", "get");
			vcc.addHandler(onPresence, null, "presence", null);
        }
        
        doConnect();
    };
    // Notifica el acceso a la conversación
    $.fn.videoservice_enter = function ( options ) {
        var settings = $.extend( {
            'callback' : function (data) {}
        }, options);
        $.ajax({
            url: endpoint + '/conversations/enter/' + options.key,
            type: 'GET',
            dataType: "jsonp",
        })
        .done(function(data){options.callback();});
    };
    $.fn.videoservice = function ( options ) {
        var settings = $.extend( {'callback' : function (data) {} }, options);        
        $.ajax({
            url: endpoint + '/api/conversations/',
            type: 'GET',
            data : {
                key : options.key
            },
            dataType: "jsonp",
        })
        .done(function(data) {
            $().videoservice_enter({
                key: options.key,
                callback: function () {
                    $().videoservice_update_chat({
                            key: options.key,
                            callback: function () {         
                                options.callback(data);
                            }});
                }});
            
        });
    };
    
    
    
    
    
    /**
     * Sent callback every XX seconds to set user is alive. If server doesn't receiver this
     * proof of life in 60 seconds, set user down.
     */
    $.fn.iAmOnline = function ( theKey, theAction )
    {
    	if (theAction != "update" && theAction != "start" && theAction != "exit")
    		theAction = "end";

    	//console.log("iAmAlive: launch function. theAction="+theAction+" theKey="+theKey+" callDisconectedByUser="+callDisconectedByUser);
    	// envia un callback cada x segundos para indicar que está funcionando.
    	$.ajax({
            url : THE_HOST+'/handlers/chatalive?key='+theKey+'&action='+theAction,
            type : 'GET',
            //data : { key : theKey, action: theAction}, 
            dataType : 'json',
            beforeSend : function(req) {
				req.setRequestHeader("Authorization", "token "+localStorage.getItem("AP_TOKEN"));                             
            },
            success: function( data ) {
                // take action if successful
            	console.log(JSON.stringify(data));
            	//console.log(vcj);
            	if (theAction == "end" || theAction == "exit"){
            		clearTimeout(controlAlive);
            		return;
            	}
            		
            	
            	
        		if (data != null && typeof data.alive !== "undefined")
        		{
        			// Call room is curently alive.
        			if (data.alive == true)
                    {
                    	iAmOnlineRetries = 2;
                    	if (theAction == "start") {
                    		console.log("iAmAlive: start 'I am alive'");
                    	}
                    	// If user is alive and not push "end call", update again after timeout
                    	else if (theAction == "update") {
                    		console.log("iAmAlive: update 'I am alive'");
                    		iAmOnlineRetries = 2;
                    	}else
                    		console.log("iAmAlive: ???? 'I am alive'");
                    	
                    	// Close if bad code
                    	if (data.code) {
                    		if (parseInt(data.code) >= 200 && parseInt(data.code) < 300) {
                    			$().reset_chat_alive();
                    			callIsDead(data.code);
                    		}
                    	}
                    	
                    	
                    }
        			// Call room is absolutely dead. Close the conversation. 
        			else if (data.alive == false)
                    {	// Conversation is down
                    	console.log("iAmAlive: call is dead");
                    	//if (!finishCode && data.code != '100')
                    	//if (!finishCode) {
                    	//	finishCode = true;
                    		callIsDead(data.code);
                    		return;
                    	//}
                    	
                    // Call data is wrong, retry (if can)	
                    }else
                	{
                    	console.log("iAmAlive: BAD 'I am alive'. we can try "+iAmOnlineRetries+" times more");
            			// Check if has another chance
                    	iAmOnlineRetries--;
            			if (iAmOnlineRetries > 0)
            				controlAlive = setTimeout(function () { $().iAmOnline(theKey, theAction); }, iAmAliveTimeout);			// TIMEOUT
            			else {
            				// CALL DATA IS CORRUPTED!!!!
            				$().reset_chat_alive();
            				callIsDead("202");
            				return;
            			}
                	}
        			
        			
        			
        			
        			
        			
        			//////////////////////////////////////////////////////////
        			// TIMER THINGS.
        			// 1. Update timer values
        			if (typeof data.free !== "undefined"){
            			if (parseInt(data.free) > 0) {
            				if (Math.abs(parseInt(data.free) - theTimer.free_timer_seconds ) > 5 )
            					theTimer.free_timer_seconds = parseInt(data.free);
            				if (theAction == "start") {
            					theAction = "update";
            					startFreeText();
            				}
            			}
            		}
            		if (typeof data.time !== "undefined")
        			{
            			if (typeof theTimer !== "undefined")
            			{
            				if (parseInt(data.time) > 0){
            					theTimer.free_timer_seconds = 0;
            					if (Math.abs(parseInt(data.time) - theTimer.pay_timer_seconds ) > 5 )
            						theTimer.pay_timer_seconds = parseInt(data.time);
            					
            					if (theAction == "start") {
            						theAction = "update";
            						startPaymentText();
            					}
            				}
            			}
        			}
            		
        			
        			// 2. Update timer status if other user is online or not
            		if (typeof data.online !== "undefined") {
            			if (typeof theTimer !== "undefined") {
            				if (data.online == '0' && theTimer.enable) {
            					if (theAction == "start") {
            						//theTimer.pause();
            						//onChats(false, true);
            					}
                    			//console.log("--OTHER OFFLINE--");
            				}else if (data.online == '1' && !theTimer.enable) {
            					//theTimer.start();
            					//onChats(true, true);
                    			//console.log("--OTHER ONLINE--");
            				}
            			}
            		}
					//////////////////////////////////////////////////////////
					//////////////////////////////////////////////////////////
        			
            		
            		
            		////////
            		if (!callDisconectedByUser)
            			controlAlive = setTimeout(function () { $().iAmOnline(theKey, theAction); }, iAmAliveTimeout);			// TIMEOUT
        			
        			
        		}else
        		{
        			console.log("iAmAlive: Problems with 'I am alive'. we can try "+iAmOnlineRetries+" times more");
        			// Check if has another chance
        			iAmOnlineRetries--;
        			if (iAmOnlineRetries > 0)
        				controlAlive = setTimeout(function () { $().iAmOnline(theKey, theAction); }, iAmAliveTimeout);			// TIMEOUT
        			else {	// Retries FAIL
        				$().reset_chat_alive();
        				callIsDead("202");
        				return;
        			}
        		}
            },
			// This method includes all non 200's codes
            error: function(jqXHR, textStatus, errorThrown) {
                // take action if failed
            	console.log("iAmAlive (ERROR): Problems with 'I am alive'. we can try "+iAmOnlineRetries+" times more");
    			// Check if has another chance
            	iAmOnlineRetries--;
    			if (iAmOnlineRetries > 0)
    				controlAlive = setTimeout(function () { $().iAmOnline(theKey, theAction); }, iAmAliveTimeout);			// TIMEOUT
    			else {	// Retries FAIL
    				
    				//$().reset_chat_alive();
    				//callIsDead("202");
    				problemDropCall();
    			}
            }
    	});

    	
    };
    
    
})( jQuery );

/**
 * Integración con plugin de Cordova
 */
window.videoservice = function(session, caller_token, called_token, role, my_key, callback)
{
	$().set_role(role);
    cordova.exec(
            callback,
            function(err) {
                callback('Nothing to echo.');
            },
            "Video",
            "start",
            [session, caller_token, called_token, role, my_key]
    );
};