/**
 * Cliente para API de VideoService
 */
(function($) {
    $.fn.videoservice_chat_jid = null;
    // Obtiene el chat interno de la conversación
    $.fn.videoservice_update_chat = function ( options )
    {
        var settings = $.extend( {
            'callback' : function (data) {}
        }, options);
        
        var endpoint = "http://pickle.mgabarda.com/video-service";
        var BOSH_SERVICE = 'http://pickle.mgabarda.com/http-bind/';
        var connection = null;
        function onConnect(status)
        {
            if (status ==  Strophe.Status.CONNECTED)
            {
                $().videoservice_chat_jid = connection.jid;
                $.ajax({
                    url : endpoint + '/conversations/update_chat/' + options.key + '?_method=POST',
                    type : 'GET',
                    data : { jid : connection.jid}, 
                    dataType : 'jsonp'
                }).done(function (data) {
                    console.log("updated chat");
                    options.callback();
                });
            }
        }
        
        connection = new Strophe.Connection(BOSH_SERVICE);
        connection.rawInput = function(data) {};
        connection.rawOutput = function(data) {};
        connection.connect('example.com', null, onConnect);
    };
    // Notifica el acceso a la conversación
    $.fn.videoservice_enter = function ( options ) {
        var endpoint = "http://pickle.mgabarda.com/video-service";
        var settings = $.extend( {
            'callback' : function (data) {}
        }, options);
        $.ajax({
            url: endpoint + '/conversations/enter/' + options.key,
            type: 'GET',
            dataType: "jsonp",
        })
        .done(function(data){options.callback();});
    };
    $.fn.videoservice = function ( options ) {
        var endpoint = "http://pickle.mgabarda.com/video-service/api";
        var settings = $.extend( {'callback' : function (data) {} }, options);
        $.ajax({
            url: endpoint + '/conversations/',
            type: 'GET',
            data : {
                key : options.key
            },
            dataType: "jsonp",
        })
        .done(function(data) {
            $().videoservice_enter({
                key: options.key,
                callback: function () {
                    $().videoservice_update_chat({
                            key: options.key,
                            callback: function () {
                                options.callback(data);
                            }});
                }});
            
        });
    };
    
})( jQuery );

/**
 * Integración con plugin de Cordova
 */
window.videoservice = function(session, caller_token, called_token, role, my_key, callback)
{
    cordova.exec(
            callback,
            function(err) {
                callback('Nothing to echo.');
            },
            "Video",
            "start",
            [session, caller_token, called_token, role, my_key]
    );
};